import Point from "./types/point";
import TableData from "./types/table-data";
import { RelationData } from "./realtion/relation";
export declare class ViewportClickEvent extends CustomEvent<Point> {
    constructor(point: Point);
}
export declare class TableClickEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableDblClickEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableContextMenuEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableMoveEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableMoveEndEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class RelationClickEvent extends CustomEvent<RelationData> {
    constructor(tableData: RelationData);
}
export declare class RelationDblClickEvent extends CustomEvent<RelationData> {
    constructor(tableData: RelationData);
}
export declare class RelationContextMenuEvent extends CustomEvent<RelationData> {
    constructor(tableData: RelationData);
}
export declare class ZoomInEvent extends CustomEvent<{
    zoom: number;
}> {
    constructor(zoom: number);
}
export declare class ZoomOutEvent extends CustomEvent<{
    zoom: number;
}> {
    constructor(zoom: number);
}
export declare class LoadEvent extends CustomEvent<void> {
    constructor();
}
export declare class ReadyEvent extends CustomEvent<void> {
    constructor();
}
export interface DbViewerEventMap extends HTMLElementEventMap {
    ready: ReadyEvent;
    load: LoadEvent;
    viewportClick: ViewportClickEvent;
    tableClick: TableClickEvent;
    tableDblClick: TableDblClickEvent;
    tableContextMenu: TableContextMenuEvent;
    relationClick: RelationClickEvent;
    relationDblClick: RelationDblClickEvent;
    relationContextMenu: RelationContextMenuEvent;
    tableMove: TableMoveEvent;
    tableMoveEnd: TableMoveEndEvent;
    zoomIn: ZoomInEvent;
    zoomOut: ZoomOutEvent;
}
