import { Schema, Viewport } from "./types/schema";
import TableData from "./types/table-data";
import { DbViewerEventMap } from "./events";
declare class DbViewer extends HTMLElement {
    get scrollLeft(): number;
    set scrollLeft(value: number);
    get scrollTop(): number;
    set scrollTop(value: number);
    set src(src: string);
    static get observedAttributes(): string[];
    set schema(schema: Schema | undefined);
    get schema(): Schema | undefined;
    set disableTableMovement(value: boolean);
    get disableTableMovement(): boolean;
    set viewport(value: Viewport | undefined);
    get viewport(): Viewport | undefined;
    private readyPromise;
    private readyPromiseResolve;
    private viewer;
    private tables;
    private srcVal;
    private viewportVal;
    private notParsedSchema;
    constructor();
    getZoom(): number;
    zoomIn(): void;
    zoomOut(): void;
    getTableInfo(name: string): TableData;
    setTablePos(name: string, xCord: number, yCord: number): void;
    attributeChangedCallback(name: string, _oldValue: string, newValue: string): void;
    private shadowDomLoaded;
    private whenWindowLoaded;
    private checkWindowLoaded;
    private onViewportClick;
    private onTableClick;
    private onTableDblClick;
    private onTableContextMenu;
    private onTableMove;
    private onTableMoveEnd;
    private onRelationClick;
    private onRelationDblClick;
    private onRelationContextMenu;
    private onZoomIn;
    private onZoomOut;
    addEventListener<K extends keyof DbViewerEventMap>(type: K, listener: (this: DbViewer, ev: DbViewerEventMap[K]) => unknown, options?: boolean | AddEventListenerOptions): void;
    removeEventListener<K extends keyof DbViewerEventMap>(type: K, listener: (this: HTMLFormElement, ev: DbViewerEventMap[K]) => unknown, options?: boolean | EventListenerOptions): void;
}
export * from "./types/schema";
export { default as Point } from "./types/point";
export * from "./events";
export default DbViewer;
