import Table from "./table";
import ViewBoxVals from "./types/view-box-vals";
import Viewer from "./viewer";
export default class Minimap {
    #private;
    private mainElem;
    private viewer;
    private svgElem;
    onContainerMouseLeave?: () => void;
    onContainerMouseUp?: () => void;
    private minimap;
    private viewpoint;
    private btnZoomIn;
    private btnZoomOut;
    private tableMinimap;
    constructor(mainElem: ShadowRoot, viewer: Viewer, svgElem: SVGGraphicsElement);
    removeTables(): void;
    resetViewBox(): void;
    reset(): void;
    setMinimapViewPoint(viewBoxVals: ViewBoxVals): void;
    createTable(table: Table): void;
    setTableDim(table: Table, x: number, y: number): void;
    onTableMove(table: Table, deltaX: number, deltaY: number): void;
    cleanUp(): void;
    private setUpEvents;
}
