import Table from "../table";
import { Column } from "../types/column";
import Orientation from "../types/orientation";
interface BasicRelation {
    fromColumn: Column;
    fromTable: Table;
    toColumn: Column;
    toTable: Table;
}
declare type ViewerCallbacks = {
    relationClick: (relationData: RelationData) => void;
    relationDblClick: (relationData: RelationData) => void;
    relationContextMenu: (relationData: RelationData) => void;
};
export declare class RelationData {
    fromTable: string;
    toTable: string;
    fromColumn: string;
    toColumn: string;
    constructor(fromTable: string, toTable: string, fromColumn: string, toColumn: string);
}
export default class Relation {
    private viewerCallbacks;
    static ySort(arr: Relation[], table: Table): void;
    static xSort(arr: Relation[], table: Table): void;
    private static sort;
    private fromColumn;
    private toColumn;
    private pathElem?;
    private fromIntersectPoint?;
    private toIntersectPoint?;
    private highlightTrigger?;
    private fromPathCount?;
    private fromPathIndex?;
    private toPathCount?;
    private toPathIndex?;
    fromTable: Table;
    toTable: Table;
    fromTablePathSide?: Orientation;
    toTablePathSide?: Orientation;
    constructor({ fromColumn, fromTable, toColumn, toTable }: BasicRelation, viewerCallbacks: ViewerCallbacks);
    update(): void;
    removeHoverEffect(): void;
    render(): [SVGGraphicsElement?, SVGGraphicsElement?];
    sameTableRelation(): boolean;
    calcPathTableSides(): boolean;
    getElems(): Element[];
    private getTableRelationSide;
    private getPosOnLine;
    private getLeftSidePathCord;
    private getRightSidePathCord;
    private getTopSidePathCord;
    private getBottomSidePathCord;
    private onMouseEnter;
    private onMouseLeave;
    private createRelationInfo;
    private onClick;
    private onDblClick;
    private onContextMenu;
    private setElems;
    setPathIndex(table: Table, count: number, pathIndex: number): number;
    private createHighlightTrigger;
    private createPath;
    remove(): void;
}
export {};
