import { Column } from "./types/column";
import Point from "./types/point";
import { TableSchema, TableArrang } from "./types/schema";
import TableData from "./types/table-data";
import Vertices from "./types/vertices";
import Viewer from "./viewer";
declare type TableMove = (table: Table, x: number, y: number, cordinatesChanged: boolean) => void;
declare type TableMoveEnd = (table: Table) => void;
declare type ViewerCallbacks = {
    tableDblClick: (data: TableData) => void;
    tableClick: (data: TableData) => void;
    tableContextMenu: (data: TableData) => void;
    tableMove: TableMove;
    tableMoveEnd: TableMoveEnd;
};
export default class Table {
    #private;
    get pos(): string | Point;
    get name(): string;
    private columns;
    private nameValue;
    private posValue;
    private disableMovementValue;
    private gElem;
    private tableElem;
    private initialClientX;
    private initialClientY;
    private foreignObject;
    private penddingCenter;
    private tablesArrangement?;
    constructor({ name, columns, pos, }: TableSchema, arrangement?: TableArrang);
    private viewerCallbacks;
    private viewer;
    setViewer(viewer: Viewer, viewCallbacks: ViewerCallbacks): void;
    getColumns(): Column[];
    setName(name: string): void;
    getName(): string;
    addColumn(column: Column): void;
    getCenter(): Point;
    getVertices(): Vertices;
    render(): SVGGraphicsElement;
    addedToView(): void;
    postDraw(): void;
    setTablePos: (x: number, y: number, disableOutOfBoundCheck?: boolean) => void;
    data(): TableData;
    highlightFrom(column: Column): void;
    removeHighlightFrom(column: Column): void;
    highlightTo(column: Column): void;
    removeHighlightTo(column: Column): void;
    disableMovement(value: boolean): void;
    private moveToTop;
    cleanup: () => void;
    private clickEvents;
    private notAllowOutOfBound;
    private isPoint;
    keepInView(): void;
    private moveEvents;
    private center;
}
export {};
