import Minimap from "./minimap";
import Table from "./table";
import ViewBoxVals from "./types/view-box-vals";
declare class ViewerEvents {
    private svgContainer;
    private viewBoxVals;
    private minimap;
    private svgElem;
    private mainElem;
    private container;
    private tables;
    private viewportClick;
    private setZoom;
    private getZoom;
    private viewportAddjustment;
    private disbleScrollEvent;
    private zoomResolve?;
    private gestureStart;
    private safariScale;
    private panXResolver?;
    private panYResolver?;
    constructor(svgContainer: HTMLElement, viewBoxVals: ViewBoxVals, minimap: Minimap, svgElem: SVGGraphicsElement, mainElem: ShadowRoot, container: HTMLElement, tables: Table[], viewportClick: (x: number, y: number) => void, setZoom: (zoom: number, targetX: number, targetY: number) => Promise<void>, getZoom: () => number, viewportAddjustment: () => void);
    setPanXResolver(panXResolver: () => void): void;
    setPanYResolver(panYResolver: () => void): void;
    setZoomResolver(zoomResolve: () => void): void;
    getGestureStart(): boolean;
    private static noneTableAndMinmapEvent;
    private onScroll;
    private onWheel;
    private onTouchMove;
    private onGesturestart;
    private onGesturechange;
    private onGestureend;
    private prevMouseCordX;
    private prevMouseCordY;
    private onMouseMove;
    private onMousedown;
    private onMouseup;
    private evCache;
    private prevDiff?;
    private onPointerdown;
    private onPointermove;
    private onPointer;
    private onClick;
    private windowResizeEvent;
    private setUpTouchEvents;
    setUpEvents(): void;
    cleanUpTouchEvents(): void;
    cleanUp(): void;
}
export default ViewerEvents;
