import Table from "./table";
import Callbacks from "./types/callbacks";
import ViewBoxVals from "./types/view-box-vals";
import Point from "./types/point";
import { TableArrang, Viewport } from "./types/schema";
export default class Viewer {
    private mainElem;
    private isTableMovementDisabled;
    private tables;
    private container;
    private svgElem;
    private svgContainer;
    private minimap;
    private disbleScrollEvent;
    private viewBoxVals;
    private zoom;
    private callbacks;
    private tablesLoaded;
    private viewLoaded;
    private viewerEvents;
    private tableArrang?;
    private viewHeight;
    private viewWidth;
    constructor(mainElem: ShadowRoot);
    private addToViewer;
    private relations;
    getTableMovementDisabled(): boolean;
    getViewLoaded(): Promise<void>;
    getViewerPanWidth(): number;
    getViewerPanHeight(): number;
    load(tables: Table[], viewport?: Viewport, tableArrang?: TableArrang, viewWidth?: number, viewHeight?: number): Promise<void>;
    private tableMove;
    private tableMoveEnd;
    draw(viewport: Viewport): Promise<void>;
    getCords(): Point;
    private viewportAddjustment;
    zoomIn: () => void;
    zoomOut: () => void;
    getZoom(): number;
    getTablePos(tableName: string): Point | string;
    getPan(): Point;
    getGestureStart(): boolean;
    getViewPort(): ViewBoxVals;
    setPanX(value: number): Promise<void>;
    setPanY(value: number): Promise<void>;
    getMousePosRelativeContainer(event: MouseEvent | TouchEvent): Point;
    setCallbacks(callbacks: Callbacks): void;
    private tableDblClick;
    private tableClick;
    private tableContextMenu;
    private relationClick;
    private relationDblClick;
    private relationContextMenu;
    disableTableMovement(value: boolean): void;
    private resetViewBox;
    private reset;
    private setViewportCenterByTableWeight;
    private setViewportCenter;
    private setViewportCenterByTables;
    setViewport(type?: Viewport): Promise<[void, void]>;
    private setZoom;
}
