import TableData from "./types/table-data";
import Point from "./types/point";
export declare class ViewportClickEvent extends CustomEvent<Point> {
    constructor(point: Point);
}
export declare class TableClickEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableDblClickEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableContextMenuEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableMoveEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class TableMoveEndEvent extends CustomEvent<TableData> {
    constructor(tableData: TableData);
}
export declare class ZoomInEvent extends CustomEvent<{
    zoom: number;
}> {
    constructor(zoom: number);
}
export declare class ZoomOutEvent extends CustomEvent<{
    zoom: number;
}> {
    constructor(zoom: number);
}
export declare class LoadEvent extends CustomEvent<void> {
    constructor();
}
export declare class ReadyEvent extends CustomEvent<void> {
    constructor();
}
interface DbViewerEventMap extends HTMLElementEventMap {
    ready: ReadyEvent;
    load: LoadEvent;
    viewportClick: ViewportClickEvent;
    tableClick: TableClickEvent;
    tableDblClick: TableDblClickEvent;
    tableContextMenu: TableContextMenuEvent;
    tableMove: TableMoveEvent;
    tableMoveEnd: TableMoveEndEvent;
    zoomIn: ZoomInEvent;
    zoomOut: ZoomOutEvent;
}
export interface DbViewerEventListeners {
    addEventListener<K extends keyof DbViewerEventMap>(type: K, listener: (this: DbViewerEventListeners, ev: DbViewerEventMap[K]) => unknown, options?: boolean | AddEventListenerOptions): void;
    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
    removeEventListener<K extends keyof DbViewerEventMap>(type: K, listener: (this: HTMLFormElement, ev: DbViewerEventMap[K]) => unknown, options?: boolean | EventListenerOptions): void;
    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
}
export {};
